using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Change_Data
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnNext;
		private System.Windows.Forms.Label lblRecordsPosition;
		private System.Windows.Forms.Button btnFirst;
		private System.Windows.Forms.Button btnPrevious;
		private System.Windows.Forms.Button btnLast;
		CurrencyManager cmRecords;
		private System.Windows.Forms.Button btnAdd;
		private System.Windows.Forms.Button btnRemove;
		private System.Windows.Forms.Button btnUpdate;
		private System.Windows.Forms.Button btnSave;
		private System.Data.OleDb.OleDbDataAdapter oleDbDataAdapter1;
		private System.Data.OleDb.OleDbCommand oleDbSelectCommand1;
		private System.Data.OleDb.OleDbCommand oleDbInsertCommand1;
		private System.Data.OleDb.OleDbCommand oleDbUpdateCommand1;
		private System.Data.OleDb.OleDbCommand oleDbDeleteCommand1;
		private System.Data.OleDb.OleDbConnection oleDbConnection1;
		private Change_Data.dsTourists dsTourists1;
		private System.Windows.Forms.TextBox txtID;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox txtFirstName;
		private System.Windows.Forms.TextBox txtLastName;
		private System.Windows.Forms.TextBox txtMiddleName;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();

			oleDbDataAdapter1.Fill(dsTourists1);
			cmRecords = (CurrencyManager)BindingContext[dsTourists1, ""];
			cmRecords.ItemChanged+=new ItemChangedEventHandler(cmRecords_ItemChanged);
			cmRecords.PositionChanged+=new EventHandler(cmRecords_PositionChanged);
			DisplayRecordsPosition();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnNext = new System.Windows.Forms.Button();
			this.lblRecordsPosition = new System.Windows.Forms.Label();
			this.btnFirst = new System.Windows.Forms.Button();
			this.btnPrevious = new System.Windows.Forms.Button();
			this.btnLast = new System.Windows.Forms.Button();
			this.btnAdd = new System.Windows.Forms.Button();
			this.btnRemove = new System.Windows.Forms.Button();
			this.btnUpdate = new System.Windows.Forms.Button();
			this.btnSave = new System.Windows.Forms.Button();
			this.oleDbDataAdapter1 = new System.Data.OleDb.OleDbDataAdapter();
			this.oleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbInsertCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbUpdateCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbDeleteCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbConnection1 = new System.Data.OleDb.OleDbConnection();
			this.dsTourists1 = new Change_Data.dsTourists();
			this.txtID = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.txtFirstName = new System.Windows.Forms.TextBox();
			this.txtLastName = new System.Windows.Forms.TextBox();
			this.txtMiddleName = new System.Windows.Forms.TextBox();
			((System.ComponentModel.ISupportInitialize)(this.dsTourists1)).BeginInit();
			this.SuspendLayout();
			// 
			// btnNext
			// 
			this.btnNext.Location = new System.Drawing.Point(168, 152);
			this.btnNext.Name = "btnNext";
			this.btnNext.Size = new System.Drawing.Size(32, 23);
			this.btnNext.TabIndex = 0;
			this.btnNext.Text = ">";
			this.btnNext.Click += new System.EventHandler(this.btnNext_Click);
			// 
			// lblRecordsPosition
			// 
			this.lblRecordsPosition.Location = new System.Drawing.Point(72, 152);
			this.lblRecordsPosition.Name = "lblRecordsPosition";
			this.lblRecordsPosition.TabIndex = 31;
			this.lblRecordsPosition.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// btnFirst
			// 
			this.btnFirst.Location = new System.Drawing.Point(16, 152);
			this.btnFirst.Name = "btnFirst";
			this.btnFirst.Size = new System.Drawing.Size(32, 23);
			this.btnFirst.TabIndex = 29;
			this.btnFirst.Text = "|<";
			this.btnFirst.Click += new System.EventHandler(this.btnFirst_Click);
			// 
			// btnPrevious
			// 
			this.btnPrevious.Location = new System.Drawing.Point(48, 152);
			this.btnPrevious.Name = "btnPrevious";
			this.btnPrevious.Size = new System.Drawing.Size(32, 23);
			this.btnPrevious.TabIndex = 27;
			this.btnPrevious.Text = "<";
			this.btnPrevious.Click += new System.EventHandler(this.btnPrevious_Click);
			// 
			// btnLast
			// 
			this.btnLast.Location = new System.Drawing.Point(200, 152);
			this.btnLast.Name = "btnLast";
			this.btnLast.Size = new System.Drawing.Size(32, 23);
			this.btnLast.TabIndex = 28;
			this.btnLast.Text = ">|";
			this.btnLast.Click += new System.EventHandler(this.btnLast_Click);
			// 
			// btnAdd
			// 
			this.btnAdd.Location = new System.Drawing.Point(8, 192);
			this.btnAdd.Name = "btnAdd";
			this.btnAdd.TabIndex = 33;
			this.btnAdd.Text = "";
			this.btnAdd.Click += new System.EventHandler(this.btnAdd_Click);
			// 
			// btnRemove
			// 
			this.btnRemove.Location = new System.Drawing.Point(168, 192);
			this.btnRemove.Name = "btnRemove";
			this.btnRemove.TabIndex = 32;
			this.btnRemove.Text = "";
			this.btnRemove.Click += new System.EventHandler(this.btnRemove_Click);
			// 
			// btnUpdate
			// 
			this.btnUpdate.Location = new System.Drawing.Point(88, 224);
			this.btnUpdate.Name = "btnUpdate";
			this.btnUpdate.TabIndex = 34;
			this.btnUpdate.Text = "";
			this.btnUpdate.Click += new System.EventHandler(this.btnUpdate_Click);
			// 
			// btnSave
			// 
			this.btnSave.Location = new System.Drawing.Point(88, 192);
			this.btnSave.Name = "btnSave";
			this.btnSave.TabIndex = 35;
			this.btnSave.Text = "";
			this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
			// 
			// oleDbDataAdapter1
			// 
			this.oleDbDataAdapter1.DeleteCommand = this.oleDbDeleteCommand1;
			this.oleDbDataAdapter1.InsertCommand = this.oleDbInsertCommand1;
			this.oleDbDataAdapter1.SelectCommand = this.oleDbSelectCommand1;
			this.oleDbDataAdapter1.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																										new System.Data.Common.DataTableMapping("Table", "", new System.Data.Common.DataColumnMapping[] {
																																																				   new System.Data.Common.DataColumnMapping("", ""),
																																																				   new System.Data.Common.DataColumnMapping("", ""),
																																																				   new System.Data.Common.DataColumnMapping("", ""),
																																																				   new System.Data.Common.DataColumnMapping("", "")})});
			this.oleDbDataAdapter1.UpdateCommand = this.oleDbUpdateCommand1;
			// 
			// oleDbSelectCommand1
			// 
			this.oleDbSelectCommand1.CommandText = "SELECT , , ,  FROM ";
			this.oleDbSelectCommand1.Connection = this.oleDbConnection1;
			// 
			// oleDbInsertCommand1
			// 
			this.oleDbInsertCommand1.CommandText = "INSERT INTO (, , ) VALUES (?, ?, ?)";
			this.oleDbInsertCommand1.Connection = this.oleDbConnection1;
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("", System.Data.OleDb.OleDbType.VarWChar, 50, ""));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("", System.Data.OleDb.OleDbType.VarWChar, 50, ""));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("", System.Data.OleDb.OleDbType.VarWChar, 50, ""));
			// 
			// oleDbUpdateCommand1
			// 
			this.oleDbUpdateCommand1.CommandText = "UPDATE  SET  = ?,  = ?,  = ? WHERE ( = ?) AND " +
				"( = ? OR ? IS NULL AND  IS NULL) AND ( = ? OR ? IS NULL AND " +
				" IS NULL) AND ( = ? OR ? IS NULL AND  IS NULL)";
			this.oleDbUpdateCommand1.Connection = this.oleDbConnection1;
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("", System.Data.OleDb.OleDbType.VarWChar, 50, ""));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("", System.Data.OleDb.OleDbType.VarWChar, 50, ""));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("", System.Data.OleDb.OleDbType.VarWChar, 50, ""));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Original, null));
			// 
			// oleDbDeleteCommand1
			// 
			this.oleDbDeleteCommand1.CommandText = "DELETE FROM  WHERE ( = ?) AND ( = ? OR ? IS NULL AND  IS N" +
				"ULL) AND ( = ? OR ? IS NULL AND  IS NULL) AND ( = ? OR ? " +
				"IS NULL AND  IS NULL)";
			this.oleDbDeleteCommand1.Connection = this.oleDbConnection1;
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Original, null));
			// 
			// oleDbConnection1
			// 
			this.oleDbConnection1.ConnectionString = @"Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Jet OLEDB:Database Password=;Data Source=""D:\Uchebnik\Code\Glava3\BDTur_firm2.mdb"";Password=;Jet OLEDB:Engine Type=5;Jet OLEDB:Global Bulk Transactions=1;Provider=""Microsoft.Jet.OLEDB.4.0"";Jet OLEDB:System database=;Jet OLEDB:SFP=False;Extended Properties=;Mode=Share Deny None;Jet OLEDB:New Database Password=;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Encrypt Database=False";
			// 
			// dsTourists1
			// 
			this.dsTourists1.DataSetName = "dsTourists";
			this.dsTourists1.Locale = new System.Globalization.CultureInfo("ru-RU");
			// 
			// txtID
			// 
			this.txtID.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsTourists1, "."));
			this.txtID.Location = new System.Drawing.Point(128, 16);
			this.txtID.Name = "txtID";
			this.txtID.TabIndex = 42;
			this.txtID.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(24, 16);
			this.label1.Name = "label1";
			this.label1.TabIndex = 39;
			this.label1.Text = " ";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(24, 80);
			this.label2.Name = "label2";
			this.label2.TabIndex = 38;
			this.label2.Text = "";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(24, 48);
			this.label3.Name = "label3";
			this.label3.TabIndex = 36;
			this.label3.Text = "";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(24, 112);
			this.label4.Name = "label4";
			this.label4.TabIndex = 37;
			this.label4.Text = "";
			// 
			// txtFirstName
			// 
			this.txtFirstName.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsTourists1, "."));
			this.txtFirstName.Location = new System.Drawing.Point(128, 80);
			this.txtFirstName.Name = "txtFirstName";
			this.txtFirstName.TabIndex = 43;
			this.txtFirstName.Text = "";
			// 
			// txtLastName
			// 
			this.txtLastName.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsTourists1, "."));
			this.txtLastName.Location = new System.Drawing.Point(128, 48);
			this.txtLastName.Name = "txtLastName";
			this.txtLastName.TabIndex = 40;
			this.txtLastName.Text = "";
			// 
			// txtMiddleName
			// 
			this.txtMiddleName.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsTourists1, "."));
			this.txtMiddleName.Location = new System.Drawing.Point(128, 112);
			this.txtMiddleName.Name = "txtMiddleName";
			this.txtMiddleName.TabIndex = 41;
			this.txtMiddleName.Text = "";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(256, 262);
			this.Controls.Add(this.txtID);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.txtFirstName);
			this.Controls.Add(this.txtLastName);
			this.Controls.Add(this.txtMiddleName);
			this.Controls.Add(this.btnSave);
			this.Controls.Add(this.btnUpdate);
			this.Controls.Add(this.btnAdd);
			this.Controls.Add(this.btnRemove);
			this.Controls.Add(this.btnNext);
			this.Controls.Add(this.btnFirst);
			this.Controls.Add(this.btnPrevious);
			this.Controls.Add(this.btnLast);
			this.Controls.Add(this.lblRecordsPosition);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.dsTourists1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void DisplayRecordsPosition()
		{
			lblRecordsPosition.Text = " " + (cmRecords.Position + 1) + "  " + cmRecords.Count;
		}
		private void cmRecords_ItemChanged( object sender, ItemChangedEventArgs e)
		{
			DisplayRecordsPosition();
		}
		private void cmRecords_PositionChanged( object sender, System.EventArgs e)
		{
			DisplayRecordsPosition();
		}
		private void btnFirst_Click(object sender, System.EventArgs e)
		{
			cmRecords.Position = 0;
		}

		private void btnPrevious_Click(object sender, System.EventArgs e)
		{
			cmRecords.Position--;
		}

		private void btnNext_Click(object sender, System.EventArgs e)
		{
			cmRecords.Position++;
		}

		private void btnLast_Click(object sender, System.EventArgs e)
		{
			cmRecords.Position = cmRecords.Count - 1;
		}

		private void btnAdd_Click(object sender, System.EventArgs e)
		{
			cmRecords.AddNew();
			btnFirst.Enabled = false;
			btnLast.Enabled = false;
			btnNext.Enabled = false;
			btnPrevious.Enabled = false;
			btnRemove.Enabled = false;
			btnUpdate.Enabled = false;
		
		}

		private void btnRemove_Click(object sender, System.EventArgs e)
		{
			if(cmRecords.Count>0)cmRecords.RemoveAt(cmRecords.Position);
			else MessageBox.Show("   !", " ", MessageBoxButtons.OK, MessageBoxIcon.Error);

		}

		private void btnUpdate_Click(object sender, System.EventArgs e)
		{
			if (dsTourists1.HasChanges())
				try
				{
					DataSet changes = dsTourists1.GetChanges();
					oleDbDataAdapter1.Update(changes);
					dsTourists1.AcceptChanges();
				}
				catch(Exception ex)
				{
					MessageBox.Show(ex.Message, " ", MessageBoxButtons.OK, MessageBoxIcon.Error);
				}
			else				
				MessageBox.Show("   ", " ", MessageBoxButtons.OK, MessageBoxIcon.Information);
				
		}

		private void btnSave_Click(object sender, System.EventArgs e)
		{
		cmRecords.Position = 0;
			btnFirst.Enabled = true;
			btnLast.Enabled = true;
			btnNext.Enabled = true;
			btnPrevious.Enabled = true;
			btnRemove.Enabled = true;
			btnUpdate.Enabled = true;
		}
	}
}
