using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;

namespace ProgrammTableMappings
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.DataGrid dataGrid1;
		string commandText = "SELECT CustomerID, CompanyName, ContactName, ContactTitle, Address, City, Region," +
			" PostalCode, Country, Phone, Fax FROM Customers";
		string connectionString = "workstation id=7EA2B2F6068D473;integrated security=SSPI;data sou" +
			"rce=\"(local)\";persist security info=False;initial catalog=NorthwindCS";

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			
			InitializeComponent();
			SqlConnection  conn = new SqlConnection();
			conn.ConnectionString = connectionString;
			SqlCommand myCommand = new SqlCommand();
			myCommand.Connection = conn;
			myCommand.CommandText = commandText;
			SqlDataAdapter dataAdapter = new SqlDataAdapter();
			dataAdapter.SelectCommand = myCommand;
			
			//  dtMapping  DataTableMapping,
			//    "Table"    
			//"DataSetTableCustomers"  DataSet:
			DataTableMapping dtMapping = new DataTableMapping("Table", "DataSetTableCustomers");

			DataColumnMapping[] dcMappings = 
				{
					new DataColumnMapping("CustomerID", "_"),
//					new DataColumnMapping("CompanyName", ""),
//					new DataColumnMapping("ContactName", ""),
					new DataColumnMapping("ContactTitle", ""),
					new DataColumnMapping("Address", ""),
					new DataColumnMapping("City", ""),
					new DataColumnMapping("Region", ""),
					new DataColumnMapping("PostalCode", ""),
					new DataColumnMapping("Country", ""),
					new DataColumnMapping("Phone", ""),
					new DataColumnMapping("Fax", ""),
					
				};

			dtMapping.ColumnMappings.AddRange(dcMappings);

			dataAdapter.TableMappings.Add(dtMapping);
//			dataAdapter.MissingMappingAction = MissingMappingAction.Passthrough;
			dataAdapter.MissingMappingAction = MissingMappingAction.Ignore;
			//dataAdapter.MissingMappingAction = MissingMappingAction.Error;
			

			DataSet dsCustomers = new DataSet();
			dataAdapter.Fill(dsCustomers);
			dataGrid1.DataSource = dsCustomers.Tables["DataSetTableCustomers"].DefaultView;
			


		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dataGrid1 = new System.Windows.Forms.DataGrid();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// dataGrid1
			// 
			this.dataGrid1.DataMember = "";
			this.dataGrid1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.dataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGrid1.Location = new System.Drawing.Point(0, 0);
			this.dataGrid1.Name = "dataGrid1";
			this.dataGrid1.Size = new System.Drawing.Size(292, 266);
			this.dataGrid1.TabIndex = 0;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.dataGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
	}
}
