using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;

namespace ProgrammUpdateWithSP
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.DataGrid dataGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		string connectionString = "integrated security=SSPI;data source=\".\"; persist security info=False; initial catalog=BDTur_firm2";
		DataSet dsTourists; 
		SqlDataAdapter dataAdapter;

		public Form1()
		{
			InitializeComponent();
			SqlConnection  conn = new SqlConnection();
			conn.ConnectionString = connectionString;
			SqlCommand mySelectCommand  = conn.CreateCommand();
			mySelectCommand.CommandText = "SELECT * FROM ";
			dataAdapter = new SqlDataAdapter();
			dataAdapter.SelectCommand = mySelectCommand;
			dsTourists = new DataSet();
			dataAdapter.Fill(dsTourists);
			dataGrid1.DataSource = dsTourists.Tables[0].DefaultView;

			//InsertCommand
			SqlCommand myInsertCommand  = conn.CreateCommand();
			myInsertCommand.CommandType = CommandType.StoredProcedure;
			myInsertCommand.CommandText = "[myInsertSP]";
			myInsertCommand.Parameters.Add("@", SqlDbType.Int, 4, "");
			myInsertCommand.Parameters.Add("@", SqlDbType.NVarChar, 50, "");
			myInsertCommand.Parameters.Add("@", SqlDbType.NVarChar, 50, "");
			myInsertCommand.Parameters.Add("@", SqlDbType.NVarChar, 50, "");
			dataAdapter.InsertCommand = myInsertCommand;
		
			//UpdateCommand
			SqlCommand myUpdateCommand  = conn.CreateCommand();
			myUpdateCommand.CommandType = CommandType.StoredProcedure;
			myUpdateCommand.CommandText = "[myUpdateSP]";
			myUpdateCommand.Parameters.Add("@", SqlDbType.Int, 4, "");
			myUpdateCommand.Parameters.Add("@", SqlDbType.NVarChar, 50, "");
			myUpdateCommand.Parameters.Add("@", SqlDbType.NVarChar, 50, "");
			myUpdateCommand.Parameters.Add("@", SqlDbType.NVarChar, 50, "");
			dataAdapter.UpdateCommand = myUpdateCommand;

			//DeleteCommand
			SqlCommand myDeleteCommand  = conn.CreateCommand();
			myDeleteCommand.CommandType = CommandType.StoredProcedure;
			myDeleteCommand.CommandText = "[myDeleteSP]";
			myDeleteCommand.Parameters.Add("@", SqlDbType.Int, 4, "");
			myDeleteCommand.Parameters.Add("@", SqlDbType.NVarChar, 50, "");
			myDeleteCommand.Parameters.Add("@", SqlDbType.NVarChar, 50, "");
			myDeleteCommand.Parameters.Add("@", SqlDbType.NVarChar, 50, "");
			dataAdapter.DeleteCommand = myDeleteCommand;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dataGrid1 = new System.Windows.Forms.DataGrid();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// dataGrid1
			// 
			this.dataGrid1.DataMember = "";
			this.dataGrid1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.dataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGrid1.Location = new System.Drawing.Point(0, 0);
			this.dataGrid1.Name = "dataGrid1";
			this.dataGrid1.Size = new System.Drawing.Size(292, 266);
			this.dataGrid1.TabIndex = 0;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.dataGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.Form1_Closing);
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			try
			{

				if (dsTourists.HasChanges())
				{
					dataAdapter.Update(dsTourists);			
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}
		}
	}
}
