using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;

namespace SomeTable
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TabControl tabControl1;
		private System.Windows.Forms.TabPage tpCustomers;
		private System.Windows.Forms.TabPage tpEmployees;
		private System.Windows.Forms.TabPage tpOrders;
		private System.Windows.Forms.DataGrid dgCustomers;
		private System.Windows.Forms.DataGrid dgEmployees;
		private System.Windows.Forms.DataGrid dgOrders;
		string commandText = "SELECT  * FROM Customers; SELECT  * FROM Employees; SELECT  * FROM Orders;";
		string connectionString = "workstation id=7EA2B2F6068D473;integrated security=SSPI;data sou" +
			"rce=\"(local)\";persist security info=False;initial catalog=NorthwindCS";

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
			SqlConnection  conn = new SqlConnection();
			conn.ConnectionString = connectionString;
			SqlCommand myCommand = new SqlCommand();
			myCommand.Connection = conn;
			myCommand.CommandText = commandText;
			SqlDataAdapter dataAdapter = new SqlDataAdapter();
			dataAdapter.SelectCommand = myCommand;
			dataAdapter.TableMappings.Add("Customers", "DataSetTableCustomers");
			dataAdapter.TableMappings.Add("Employees", "DataSetTableEmployees");
			dataAdapter.TableMappings.Add("Orders", "DataSetTableOrders");

			DataSet ds = new DataSet();
			dataAdapter.Fill(ds);
			dgCustomers.DataSource = ds.Tables[0].DefaultView;
			dgEmployees.DataSource = ds.Tables[1].DefaultView;
			dgOrders.DataSource = ds.Tables[2].DefaultView;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.tabControl1 = new System.Windows.Forms.TabControl();
			this.tpCustomers = new System.Windows.Forms.TabPage();
			this.tpEmployees = new System.Windows.Forms.TabPage();
			this.tpOrders = new System.Windows.Forms.TabPage();
			this.dgCustomers = new System.Windows.Forms.DataGrid();
			this.dgEmployees = new System.Windows.Forms.DataGrid();
			this.dgOrders = new System.Windows.Forms.DataGrid();
			this.tabControl1.SuspendLayout();
			this.tpCustomers.SuspendLayout();
			this.tpEmployees.SuspendLayout();
			this.tpOrders.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.dgCustomers)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dgEmployees)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dgOrders)).BeginInit();
			this.SuspendLayout();
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.Add(this.tpCustomers);
			this.tabControl1.Controls.Add(this.tpEmployees);
			this.tabControl1.Controls.Add(this.tpOrders);
			this.tabControl1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tabControl1.Location = new System.Drawing.Point(0, 0);
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(292, 266);
			this.tabControl1.TabIndex = 0;
			// 
			// tpCustomers
			// 
			this.tpCustomers.Controls.Add(this.dgCustomers);
			this.tpCustomers.Location = new System.Drawing.Point(4, 22);
			this.tpCustomers.Name = "tpCustomers";
			this.tpCustomers.Size = new System.Drawing.Size(284, 240);
			this.tpCustomers.TabIndex = 0;
			this.tpCustomers.Text = "Customers";
			// 
			// tpEmployees
			// 
			this.tpEmployees.Controls.Add(this.dgEmployees);
			this.tpEmployees.Location = new System.Drawing.Point(4, 22);
			this.tpEmployees.Name = "tpEmployees";
			this.tpEmployees.Size = new System.Drawing.Size(284, 240);
			this.tpEmployees.TabIndex = 1;
			this.tpEmployees.Text = "Employees";
			// 
			// tpOrders
			// 
			this.tpOrders.Controls.Add(this.dgOrders);
			this.tpOrders.Location = new System.Drawing.Point(4, 22);
			this.tpOrders.Name = "tpOrders";
			this.tpOrders.Size = new System.Drawing.Size(284, 240);
			this.tpOrders.TabIndex = 2;
			this.tpOrders.Text = "Orders";
			// 
			// dgCustomers
			// 
			this.dgCustomers.DataMember = "";
			this.dgCustomers.Dock = System.Windows.Forms.DockStyle.Fill;
			this.dgCustomers.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dgCustomers.Location = new System.Drawing.Point(0, 0);
			this.dgCustomers.Name = "dgCustomers";
			this.dgCustomers.Size = new System.Drawing.Size(284, 240);
			this.dgCustomers.TabIndex = 1;
			// 
			// dgEmployees
			// 
			this.dgEmployees.DataMember = "";
			this.dgEmployees.Dock = System.Windows.Forms.DockStyle.Fill;
			this.dgEmployees.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dgEmployees.Location = new System.Drawing.Point(0, 0);
			this.dgEmployees.Name = "dgEmployees";
			this.dgEmployees.Size = new System.Drawing.Size(284, 240);
			this.dgEmployees.TabIndex = 1;
			// 
			// dgOrders
			// 
			this.dgOrders.DataMember = "";
			this.dgOrders.Dock = System.Windows.Forms.DockStyle.Fill;
			this.dgOrders.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dgOrders.Location = new System.Drawing.Point(0, 0);
			this.dgOrders.Name = "dgOrders";
			this.dgOrders.Size = new System.Drawing.Size(284, 240);
			this.dgOrders.TabIndex = 1;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.tabControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.tabControl1.ResumeLayout(false);
			this.tpCustomers.ResumeLayout(false);
			this.tpEmployees.ResumeLayout(false);
			this.tpOrders.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.dgCustomers)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dgEmployees)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dgOrders)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
	}
}
