using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.OleDb;

namespace StoredProcedures_in_Access
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.DataGrid dataGrid1;
		string connectionString = @"Provider=""Microsoft.Jet.OLEDB.4.0"";Data Source=""D:\Uchebnik\Code\Glava6\BDTur_firm3.mdb"";User ID=Admin;Jet OLEDB:Encrypt Database=False";
		DataSet dsTourists; 
		OleDbDataAdapter dataAdapter;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
			OleDbConnection  conn = new OleDbConnection();
			conn.ConnectionString = connectionString;
			OleDbCommand mySelectCommand  = conn.CreateCommand();
			mySelectCommand.CommandText = "SELECT * FROM ";
			dataAdapter = new OleDbDataAdapter();
			dataAdapter.SelectCommand = mySelectCommand;
			dsTourists = new DataSet();
			dataAdapter.Fill(dsTourists);
			dataGrid1.DataSource = dsTourists.Tables[0].DefaultView;

			//InsertCommand
			OleDbCommand myInsertCommand  = conn.CreateCommand();
			myInsertCommand.CommandText = "INSERT INTO  (, , ) VALUES (?, ?, ?)";
			myInsertCommand.Parameters.Add("@", OleDbType.VarWChar, 50, "");
			myInsertCommand.Parameters.Add("@", OleDbType.VarWChar, 50, "");
			myInsertCommand.Parameters.Add("@", OleDbType.VarWChar, 50, "");
			dataAdapter.InsertCommand = myInsertCommand;

			//UpdateCommand
			OleDbCommand myUpdateCommand  = conn.CreateCommand();
			myUpdateCommand.CommandText = "UPDATE  SET  = ?,  = ?,  = ? WHERE ( = ?)";
			myUpdateCommand.Parameters.Add("@", System.Data.OleDb.OleDbType.VarWChar, 50, "");
			myUpdateCommand.Parameters.Add("@", System.Data.OleDb.OleDbType.VarWChar, 50, "");
			myUpdateCommand.Parameters.Add("@", System.Data.OleDb.OleDbType.VarWChar, 50, "");
			myUpdateCommand.Parameters.Add(new OleDbParameter("@", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Original, null));
			dataAdapter.UpdateCommand = myUpdateCommand;

			//DeleteCommand
			OleDbCommand myDeleteCommand  = conn.CreateCommand();
			myDeleteCommand.CommandText = "DELETE FROM  WHERE ( = ?) OR  ( = ?) OR ( = ?)";
			myDeleteCommand.Parameters.Add("@", OleDbType.VarWChar, 50, "");
			myDeleteCommand.Parameters.Add("@", OleDbType.VarWChar, 50, "");
			myDeleteCommand.Parameters.Add("@", OleDbType.VarWChar, 50, "");
			dataAdapter.DeleteCommand = myDeleteCommand;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dataGrid1 = new System.Windows.Forms.DataGrid();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// dataGrid1
			// 
			this.dataGrid1.DataMember = "";
			this.dataGrid1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.dataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGrid1.Location = new System.Drawing.Point(0, 0);
			this.dataGrid1.Name = "dataGrid1";
			this.dataGrid1.Size = new System.Drawing.Size(292, 266);
			this.dataGrid1.TabIndex = 0;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.dataGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.Form1_Closing);
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			try
			{

				if (dsTourists.HasChanges())
				{
					dataAdapter.Update(dsTourists);			
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}
		}
	}
}
